﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_click_any_control
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // Look for WM_MOUSEACTIVATE messages.
        protected override void WndProc(ref Message m)
        {
            //Console.WriteLine(m.Msg);//@

            // Look for WM_MOUSEACTIVATE.
            const UInt32 WM_MOUSEACTIVATE = 0x0021;
            if (m.Msg == WM_MOUSEACTIVATE)
            {
                // See where the mouse is.
                Point screen_coords = Cursor.Position;

                // Start looking at the form's children.
                Control ctl = this;
                for (; ; )
                {
                    // Convert the mouse's position into
                    // the control's coordinate system.
                    Point ctl_coords = ctl.PointToClient(screen_coords);

                    // See if there is a child at this position.
                    Control child = ctl.GetChildAtPoint(ctl_coords, GetChildAtPointSkip.Invisible);
                    if (child == null) break;

                    // Search the child.
                    ctl = child;
                }

                // Display the innermost control at this point.
                txtControl.Text = ctl.Name;
            }

            base.WndProc(ref m);
        }
    }
}
